#include <usplash-theme.h>
#include <usplash_backend.h>
#include "usplash_verticale.h"

void up_down(struct usplash_theme* theme, struct usplash_pixmap* back, struct usplash_pixmap* fore,  int percentage){
	int w = (back->height * percentage / 100);
	if(percentage < 0){/* Unloading */
        w = back->height + w;
	}
	/* Draw progress bar foreground on top of background */
        usplash_put_part(theme->progressbar_x, theme->progressbar_y, fore->width, w, fore, 0, 0);
        /* Draw progress bar background under the foreground */
        usplash_put_part(theme->progressbar_x, theme->progressbar_y+w, back->width, back->height -w, back, 0, w);
}


void down_up(struct usplash_theme* theme, struct usplash_pixmap* back, struct usplash_pixmap* fore, int percentage){
	int w = (back->height * percentage / 100);
	if(percentage < 0){/* Unloading */
        w = back->height + w;
	}
	/* Draw progress bar background on top of foreground */
        usplash_put_part(theme->progressbar_x, theme->progressbar_y, back->width, back->height - w, back, 0, 0);
        /* Draw progress bar foreground under the background */
        usplash_put_part(theme->progressbar_x, theme->progressbar_y + back->height - w, back->width, w, fore, 0, back->height - w);
}

void pulsate(struct usplash_theme* theme, struct usplash_pixmap* back, struct usplash_pixmap* fore){
    static int pulsate_step = 0;
    static int pulse_height = 56;
    static int step_height = 2;
    static int num_steps = 0;
    int y1;
    int y2;
    num_steps = (fore->height - pulse_height)/2;
    if(pulsate_step < num_steps/2+1){
        y1 = 2 * step_height * pulsate_step;
    }
    else{
        y1 = fore->height - pulse_height - 2 * step_height * (pulsate_step - num_steps/2+1);
    }
    y2 = y1 + pulse_height;

    /* Draw progress bar background on top of foreground 'pulse' */
    usplash_put_part(theme->progressbar_x, theme->progressbar_y, back->width, y1, back, 0, 0);
    /* Draw progress bar foreground 'pulse' */
    usplash_put_part(theme->progressbar_x, theme->progressbar_y + y1, back->width, pulse_height, fore, 0, y1);
    /* Draw progress bar background under the foreground 'pulse' */
    usplash_put_part(theme->progressbar_x, theme->progressbar_y + y2, back->width, back->height - y2, back, 0, y2);

    pulsate_step = (pulsate_step + 1) % num_steps;
}
